<html>
<head>
<title>OgreD3D9HLSLProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_c7ffc14721c8bed1493f4f78ca8c7331.html">Direct3D9</a>      </li>
      <li class="navelem"><a class="el" href="dir_1208738e8444befc5f502320df40a1ea.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D9HLSLProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D9HLSLProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D9HLSLProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D9HLSLProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Prerequisites_8h.html">OgreD3D9Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHighLevelGpuProgram_8h.html">OgreHighLevelGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00043"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html">00043</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for D3D9 High-Level Shader Language (HLSL)...">D3D9HLSLProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045     <span class="keyword">public</span>:
<a name="l00047"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdEntryPoint.html">00047</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdEntryPoint.html" title="Command object for setting entry point.">CmdEntryPoint</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00048"></a>00048         {
<a name="l00049"></a>00049         <span class="keyword">public</span>:
<a name="l00050"></a>00050             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00051"></a>00051             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00052"></a>00052         };
<a name="l00054"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdTarget.html">00054</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdTarget.html" title="Command object for setting target assembler.">CmdTarget</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00055"></a>00055         {
<a name="l00056"></a>00056         <span class="keyword">public</span>:
<a name="l00057"></a>00057             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00058"></a>00058             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00059"></a>00059         };
<a name="l00061"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdPreprocessorDefines.html">00061</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00062"></a>00062         {
<a name="l00063"></a>00063         <span class="keyword">public</span>:
<a name="l00064"></a>00064             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00065"></a>00065             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00066"></a>00066         };
<a name="l00068"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdColumnMajorMatrices.html">00068</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdColumnMajorMatrices.html" title="Command object for setting matrix packing in column-major order.">CmdColumnMajorMatrices</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00069"></a>00069         {
<a name="l00070"></a>00070         <span class="keyword">public</span>:
<a name="l00071"></a>00071             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00072"></a>00072             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00073"></a>00073         };
<a name="l00075"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdOptimisation.html">00075</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdOptimisation.html" title="Command object for setting optimisation level.">CmdOptimisation</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00076"></a>00076         {
<a name="l00077"></a>00077         <span class="keyword">public</span>:
<a name="l00078"></a>00078             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00079"></a>00079             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00080"></a>00080         };
<a name="l00081"></a>00081 
<a name="l00083"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdMicrocode.html">00083</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdMicrocode.html" title="Command object for getting/setting micro code.">CmdMicrocode</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085         <span class="keyword">public</span>:
<a name="l00086"></a>00086             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00087"></a>00087             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00088"></a>00088         };
<a name="l00089"></a>00089 
<a name="l00091"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdAssemblerCode.html">00091</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdAssemblerCode.html" title="Command object for getting/setting assembler code.">CmdAssemblerCode</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093         <span class="keyword">public</span>:
<a name="l00094"></a>00094             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00095"></a>00095             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00096"></a>00096         };
<a name="l00097"></a>00097     <span class="keyword">protected</span>:
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#af5124e67981936f8129a6ecd5dfaabe7">00099</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdEntryPoint.html" title="Command object for setting entry point.">CmdEntryPoint</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#af5124e67981936f8129a6ecd5dfaabe7">msCmdEntryPoint</a>;
<a name="l00100"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#acf4b2909ea39222c72127e7aba82c9ab">00100</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdTarget.html" title="Command object for setting target assembler.">CmdTarget</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#acf4b2909ea39222c72127e7aba82c9ab">msCmdTarget</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a4ce345e1c0d670f337c7bfb0ab6553a2">00101</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a4ce345e1c0d670f337c7bfb0ab6553a2">msCmdPreprocessorDefines</a>;
<a name="l00102"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a18e028bea73d050ee5264fd5ad6eb64f">00102</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdColumnMajorMatrices.html" title="Command object for setting matrix packing in column-major order.">CmdColumnMajorMatrices</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a18e028bea73d050ee5264fd5ad6eb64f">msCmdColumnMajorMatrices</a>;
<a name="l00103"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a99b779ee5e6644f3c4fc7181c3c466a5">00103</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdOptimisation.html" title="Command object for setting optimisation level.">CmdOptimisation</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a99b779ee5e6644f3c4fc7181c3c466a5">msCmdOptimisation</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab8b87c2b8f16d7116d72c3ec7c226000">00104</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdMicrocode.html" title="Command object for getting/setting micro code.">CmdMicrocode</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab8b87c2b8f16d7116d72c3ec7c226000">msCmdMicrocode</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a21e39472ff595a86695f65deba5faa81">00105</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram_1_1CmdAssemblerCode.html" title="Command object for getting/setting assembler code.">CmdAssemblerCode</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a21e39472ff595a86695f65deba5faa81">msCmdAssemblerCode</a>;
<a name="l00106"></a>00106 
<a name="l00109"></a>00109         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00112"></a>00112         <span class="keywordtype">void</span> createLowLevelImpl(<span class="keywordtype">void</span>);
<a name="l00114"></a>00114         <span class="keywordtype">void</span> unloadHighLevelImpl(<span class="keywordtype">void</span>);
<a name="l00116"></a>00116         <span class="keywordtype">void</span> buildConstantDefinitions() <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118         <span class="comment">// Recursive utility method for buildParamNameMap</span>
<a name="l00119"></a>00119         <span class="keywordtype">void</span> processParamElement(LPD3DXCONSTANTTABLE pConstTable, D3DXHANDLE parent, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> prefix, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00120"></a>00120         <span class="keywordtype">void</span> populateDef(D3DXCONSTANT_DESC&amp; d3dDesc, <a class="code" href="structOgre_1_1GpuConstantDefinition.html" title="Information about predefined program constants.">GpuConstantDefinition</a>&amp; def) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a28c5338af5c42d7fc6dd6fb45fca2cf5">00122</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a28c5338af5c42d7fc6dd6fb45fca2cf5">mTarget</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a578eb153325f5a4ab3a6b2da9ca2f08f">00123</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a578eb153325f5a4ab3a6b2da9ca2f08f">mEntryPoint</a>;
<a name="l00124"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a722bffbbacbb4b1efaaf63b1eae60c64">00124</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a722bffbbacbb4b1efaaf63b1eae60c64">mPreprocessorDefines</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a85b094b610977147bc906ecdb4c64f52">00125</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a85b094b610977147bc906ecdb4c64f52">mColumnMajorMatrices</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a44c0aea28c4bc77ea2ce31e24f738626">00127</a>         LPD3DXBUFFER <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a44c0aea28c4bc77ea2ce31e24f738626">mMicroCode</a>;
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a9f1b828e43b8396fc87304f7a7d1e09a">00129</a>         <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a9f1b828e43b8396fc87304f7a7d1e09a">mParametersMap</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#abda6264b3a8b39d2182672eabcb49ec5">00130</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#abda6264b3a8b39d2182672eabcb49ec5">mParametersMapSizeAsBuffer</a>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     <span class="keyword">public</span>:
<a name="l00133"></a>00133         LPD3DXBUFFER getMicroCode();
<a name="l00134"></a>00134     <span class="keyword">public</span>:
<a name="l00136"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117">00136</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117" title="Shader optimisation level.">OptimisationLevel</a>
<a name="l00137"></a>00137         {
<a name="l00139"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a803f232baf679f286679b8ece0ba2ece">00139</a>             <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a803f232baf679f286679b8ece0ba2ece" title="default - no optimisation in debug mode, OPT_1 in release mode">OPT_DEFAULT</a>,
<a name="l00141"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a74ff7fb598593fcdabdbf80569d8a252">00141</a>             <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a74ff7fb598593fcdabdbf80569d8a252" title="No optimisation.">OPT_NONE</a>,
<a name="l00143"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a7b60cc8e10a234b14b4adbcdcbf917c1">00143</a>             <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a7b60cc8e10a234b14b4adbcdcbf917c1" title="Optimisation level 0.">OPT_0</a>, 
<a name="l00145"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a3549efac010294085db5a02512e8c59f">00145</a>             <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117a3549efac010294085db5a02512e8c59f" title="Optimisation level 1.">OPT_1</a>,
<a name="l00147"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117aa6f8763da088618fde07dbffbe110526">00147</a>             <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117aa6f8763da088618fde07dbffbe110526" title="Optimisation level 2.">OPT_2</a>, 
<a name="l00149"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117ae735171937c5d069b6ca58281ff3ada1">00149</a>             OPT_3
<a name="l00150"></a>00150         };
<a name="l00151"></a>00151     <span class="keyword">protected</span>:
<a name="l00152"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a4ed7320d7112ea762976024176d8d77f">00152</a>         <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117" title="Shader optimisation level.">OptimisationLevel</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a4ed7320d7112ea762976024176d8d77f">mOptimisationLevel</a>;
<a name="l00153"></a>00153 
<a name="l00155"></a>00155         <span class="keywordtype">void</span> getMicrocodeFromCache(<span class="keywordtype">void</span>);
<a name="l00157"></a>00157         <span class="keywordtype">void</span> compileMicrocode(<span class="keywordtype">void</span>);
<a name="l00158"></a>00158         <span class="keywordtype">void</span> addMicrocodeToCache();
<a name="l00159"></a>00159     <span class="keyword">public</span>:
<a name="l00160"></a>00160         <a class="code" href="classOgre_1_1D3D9HLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for D3D9 High-Level Shader Language (HLSL)...">D3D9HLSLProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00161"></a>00161             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00162"></a>00162         ~<a class="code" href="classOgre_1_1D3D9HLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for D3D9 High-Level Shader Language (HLSL)...">D3D9HLSLProgram</a>();
<a name="l00163"></a>00163 
<a name="l00165"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab5ac0fb0522810c2c32a0d7cd157b4ac">00165</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab5ac0fb0522810c2c32a0d7cd157b4ac" title="Sets the entry point for this program ie the first method called.">setEntryPoint</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; entryPoint) { mEntryPoint = entryPoint; }
<a name="l00167"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ade3799dac94b4d001fee3fc707b03c27">00167</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ade3799dac94b4d001fee3fc707b03c27" title="Gets the entry point defined for this program.">getEntryPoint</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mEntryPoint; }
<a name="l00169"></a>00169         <span class="keywordtype">void</span> setTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; target);
<a name="l00171"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#af18df73a5251742e72e7f6463ba86568">00171</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#af18df73a5251742e72e7f6463ba86568" title="Gets the shader target to compile down to, e.g.">getTarget</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTarget; }
<a name="l00173"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a804ceed2fd7fe40592b1c2f43c4ec83c">00173</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a804ceed2fd7fe40592b1c2f43c4ec83c" title="Sets the preprocessor defines use to compile the program.">setPreprocessorDefines</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; defines) { mPreprocessorDefines = defines; }
<a name="l00175"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ac60ecd34d8b698b60c0b3cb6352d5c8d">00175</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ac60ecd34d8b698b60c0b3cb6352d5c8d" title="Sets the preprocessor defines use to compile the program.">getPreprocessorDefines</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPreprocessorDefines; }
<a name="l00177"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a8dc14aed0a6b5fa3c10da5bc03ea5dc1">00177</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a8dc14aed0a6b5fa3c10da5bc03ea5dc1" title="Sets whether matrix packing in column-major order.">setColumnMajorMatrices</a>(<span class="keywordtype">bool</span> columnMajor) { mColumnMajorMatrices = columnMajor; }
<a name="l00179"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab5c3e80f6170a24fceb3890bbf6bb7d1">00179</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab5c3e80f6170a24fceb3890bbf6bb7d1" title="Gets whether matrix packed in column-major order.">getColumnMajorMatrices</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mColumnMajorMatrices; }
<a name="l00183"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab7056809b6c2215b4a5feb5eaed4b5cd">00183</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#ab7056809b6c2215b4a5feb5eaed4b5cd" title="Sets the optimisation level to use.">setOptimisationLevel</a>(<a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117" title="Shader optimisation level.">OptimisationLevel</a> opt) { mOptimisationLevel = opt; }
<a name="l00184"></a>00184 
<a name="l00186"></a><a class="code" href="classOgre_1_1D3D9HLSLProgram.html#afee67d97776a6e91acba1219b7ac87ed">00186</a>         <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#a549748dee587b870ec40786d64888117" title="Shader optimisation level.">OptimisationLevel</a> <a class="code" href="classOgre_1_1D3D9HLSLProgram.html#afee67d97776a6e91acba1219b7ac87ed" title="Gets the optimisation level to use.">getOptimisationLevel</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOptimisationLevel; }
<a name="l00187"></a>00187 
<a name="l00189"></a>00189         <span class="keywordtype">bool</span> isSupported(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00191"></a>00191         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00193"></a>00193         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getLanguage(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00194"></a>00194     };
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
